// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from derived_object_msgs:msg/CipvTrack.idl
// generated code does not contain a copyright notice

#ifndef DERIVED_OBJECT_MSGS__MSG__CIPV_TRACK__STRUCT_HPP_
#define DERIVED_OBJECT_MSGS__MSG__CIPV_TRACK__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"
// Member 'track'
#include "radar_msgs/msg/radar_track__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__derived_object_msgs__msg__CipvTrack __attribute__((deprecated))
#else
# define DEPRECATED__derived_object_msgs__msg__CipvTrack __declspec(deprecated)
#endif

namespace derived_object_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CipvTrack_
{
  using Type = CipvTrack_<ContainerAllocator>;

  explicit CipvTrack_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init),
    track(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_valid = false;
    }
  }

  explicit CipvTrack_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    track(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _is_valid_type =
    bool;
  _is_valid_type is_valid;
  using _track_type =
    radar_msgs::msg::RadarTrack_<ContainerAllocator>;
  _track_type track;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__is_valid(
    const bool & _arg)
  {
    this->is_valid = _arg;
    return *this;
  }
  Type & set__track(
    const radar_msgs::msg::RadarTrack_<ContainerAllocator> & _arg)
  {
    this->track = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    derived_object_msgs::msg::CipvTrack_<ContainerAllocator> *;
  using ConstRawPtr =
    const derived_object_msgs::msg::CipvTrack_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      derived_object_msgs::msg::CipvTrack_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      derived_object_msgs::msg::CipvTrack_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__derived_object_msgs__msg__CipvTrack
    std::shared_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__derived_object_msgs__msg__CipvTrack
    std::shared_ptr<derived_object_msgs::msg::CipvTrack_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CipvTrack_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->is_valid != other.is_valid) {
      return false;
    }
    if (this->track != other.track) {
      return false;
    }
    return true;
  }
  bool operator!=(const CipvTrack_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CipvTrack_

// alias to use template instance with default allocator
using CipvTrack =
  derived_object_msgs::msg::CipvTrack_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace derived_object_msgs

#endif  // DERIVED_OBJECT_MSGS__MSG__CIPV_TRACK__STRUCT_HPP_
