#ifndef _H_422652A74F8F435B23E558A81A4EFFD9_CipvTrack_DCPS_H_
#define _H_422652A74F8F435B23E558A81A4EFFD9_CipvTrack_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CipvTrack_.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CipvTrack_TypeSupportInterface;

            typedef CipvTrack_TypeSupportInterface * CipvTrack_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CipvTrack_TypeSupportInterface> CipvTrack_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CipvTrack_TypeSupportInterface> CipvTrack_TypeSupportInterface_out;


            class CipvTrack_DataWriter;

            typedef CipvTrack_DataWriter * CipvTrack_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CipvTrack_DataWriter> CipvTrack_DataWriter_var;
            typedef DDS_DCPSInterface_out < CipvTrack_DataWriter> CipvTrack_DataWriter_out;


            class CipvTrack_DataReader;

            typedef CipvTrack_DataReader * CipvTrack_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CipvTrack_DataReader> CipvTrack_DataReader_var;
            typedef DDS_DCPSInterface_out < CipvTrack_DataReader> CipvTrack_DataReader_out;


            class CipvTrack_DataReaderView;

            typedef CipvTrack_DataReaderView * CipvTrack_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CipvTrack_DataReaderView> CipvTrack_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CipvTrack_DataReaderView> CipvTrack_DataReaderView_out;

            struct CipvTrack_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CipvTrack_, struct CipvTrack_Seq_uniq_> CipvTrack_Seq;
            typedef DDS_DCPSSequence_var < CipvTrack_Seq> CipvTrack_Seq_var;
            typedef DDS_DCPSSequence_out < CipvTrack_Seq> CipvTrack_Seq_out;

            class  CipvTrack_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CipvTrack_TypeSupportInterface_ptr _ptr_type;
                typedef CipvTrack_TypeSupportInterface_var _var_type;

                static CipvTrack_TypeSupportInterface_ptr _duplicate (CipvTrack_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CipvTrack_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CipvTrack_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CipvTrack_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CipvTrack_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CipvTrack_TypeSupportInterface () {};
                ~CipvTrack_TypeSupportInterface () {};
            private:
                CipvTrack_TypeSupportInterface (const CipvTrack_TypeSupportInterface &);
                CipvTrack_TypeSupportInterface & operator = (const CipvTrack_TypeSupportInterface &);
            };

            class  CipvTrack_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CipvTrack_DataWriter_ptr _ptr_type;
                typedef CipvTrack_DataWriter_var _var_type;

                static CipvTrack_DataWriter_ptr _duplicate (CipvTrack_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CipvTrack_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CipvTrack_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CipvTrack_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CipvTrack_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CipvTrack_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CipvTrack_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CipvTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CipvTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CipvTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CipvTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CipvTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CipvTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CipvTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CipvTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CipvTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CipvTrack_& instance_data) = 0;

            protected:
                CipvTrack_DataWriter () {};
                ~CipvTrack_DataWriter () {};
            private:
                CipvTrack_DataWriter (const CipvTrack_DataWriter &);
                CipvTrack_DataWriter & operator = (const CipvTrack_DataWriter &);
            };

            class  CipvTrack_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CipvTrack_DataReader_ptr _ptr_type;
                typedef CipvTrack_DataReader_var _var_type;

                static CipvTrack_DataReader_ptr _duplicate (CipvTrack_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CipvTrack_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CipvTrack_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CipvTrack_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CipvTrack_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CipvTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CipvTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CipvTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CipvTrack_& instance) = 0;

            protected:
                CipvTrack_DataReader () {};
                ~CipvTrack_DataReader () {};
            private:
                CipvTrack_DataReader (const CipvTrack_DataReader &);
                CipvTrack_DataReader & operator = (const CipvTrack_DataReader &);
            };

            class  CipvTrack_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CipvTrack_DataReaderView_ptr _ptr_type;
                typedef CipvTrack_DataReaderView_var _var_type;

                static CipvTrack_DataReaderView_ptr _duplicate (CipvTrack_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CipvTrack_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CipvTrack_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CipvTrack_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CipvTrack_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CipvTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CipvTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CipvTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CipvTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CipvTrack_& instance) = 0;

            protected:
                CipvTrack_DataReaderView () {};
                ~CipvTrack_DataReaderView () {};
            private:
                CipvTrack_DataReaderView (const CipvTrack_DataReaderView &);
                CipvTrack_DataReaderView & operator = (const CipvTrack_DataReaderView &);
            };
        }

    }

}

#endif
